<template>
  <q-layout view="lHh Lpr lFf">
    <q-header>
      <q-toolbar>
        <q-btn
          flat
          dense
          round
          @click="leftDrawerOpen = !leftDrawerOpen"
          aria-label="Menu"
        >
          <q-icon name="menu" />
        </q-btn>

        <q-toolbar-title>
          Vue Quasar Boilerplate
        </q-toolbar-title>

        <q-chip>
          <q-avatar>
            <img src="https://cdn.quasar.dev/img/boy-avatar.png" />
          </q-avatar>
          {{ name }}
          <q-menu transition-show="jump-down" transition-hide="jump-up">
            <q-list style="min-width: 100px">
              <q-item-label class="q-pa-sm bg-grey-4">
                {{ user ? user.email : '' }}
              </q-item-label>
              <q-item clickable @click="logout">
                <q-item-section>Logout</q-item-section>
              </q-item>
            </q-list>
          </q-menu>
        </q-chip>
      </q-toolbar>
    </q-header>

    <q-drawer
      v-model="leftDrawerOpen"
      bordered
      content-class="bg-grey-2"
      :width="260"
    >
      <q-list>
        <q-item
          v-for="menuItem in menuItems"
          :key="menuItem.to + menuItem.label"
          clickable
          :to="menuItem.to"
          :exact="menuItem.exact"
        >
          <q-item-section avatar>
            <q-icon :name="menuItem.icon" />
          </q-item-section>
          <q-item-section>
            <q-item-label>{{ menuItem.label }}</q-item-label>
            <q-item-label v-if="menuItem.description" caption>{{
              menuItem.description
            }}</q-item-label>
          </q-item-section>
        </q-item>
      </q-list>
    </q-drawer>

    <q-page-container>
      <router-view />
    </q-page-container>
  </q-layout>
</template>

<script>
export default {
  name: 'MainLayout',
  data() {
    return {
      leftDrawerOpen: this.$q.platform.is.desktop,
      menuItems: [
        {
          label: 'Home',
          to: '/',
          icon: 'home',
          exact: true,
        },
        {
          label: 'Pokemons',
          to: '/pokemons',
          icon: 'import_contacts',
        },
        {
          label: 'SW Planets',
          to: '/planets',
          icon: 'import_contacts',
        },
      ],
    }
  },
  computed: {
    user() {
      return this.$store.state.auth.user
    },
    name() {
      return this.user ? `${this.user.firstname} ${this.user.surname}` : ''
    },
  },
  methods: {
    logout() {
      this.$store.dispatch('auth/logout')
    },
  },
}
</script>
